package com.gic.plug.web.controller.goods;

import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.commons.contants.SortType;
import com.gic.commons.util.PageHelperUtils;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.goods.api.dto.StandardDTO;
import com.gic.goods.api.dto.StandardValueDTO;
import com.gic.goods.api.dto.StandardValueGroupDTO;
import com.gic.goods.api.service.StandardApiService;
import com.gic.goods.api.service.StandardValueApiService;
import com.gic.goods.api.service.StandardValueGroupApiService;
import com.gic.plug.web.vo.goods.GoodsStandardVO;
import com.gic.plug.web.vo.goods.GoodsStandardValueGroupVO;
import com.gic.plug.web.vo.goods.GoodsStandardValueVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class GoodsStandardController extends BaseController {

    @Autowired
    private StandardApiService standardApiService;

    @Autowired
    private StandardValueApiService standardValueApiService;

    @Autowired
    private StandardValueGroupApiService standardValueGroupApiService;

    @RequestMapping("/list-standard")
    public RestResponse listStandard(int currentPage, int pageSize, String search, Long goodsDomainId) {
        ServiceResponse<Page<StandardDTO>> serviceResponse = standardApiService.listByPage(currentPage, pageSize, goodsDomainId, search, getEnterpriseId());
        if (!serviceResponse.isSuccess()) {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
        Page<GoodsStandardVO> page = PageHelperUtils.changePageToCurrentPage(serviceResponse.getResult(), GoodsStandardVO.class);
        return RestResponse.success(page);
    }


    @RequestMapping("/list-standard-value-group")
    public RestResponse listStandardValueGroup(int currentPage, int pageSize, Long specStandardId, String search) {
        ServiceResponse<Page<StandardValueGroupDTO>> serviceResponse =
                standardValueGroupApiService.listByPage(currentPage, pageSize, specStandardId, search, SortType.sortDescType, getEnterpriseId());
        if (!serviceResponse.isSuccess()) {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
        Page<GoodsStandardValueGroupVO> page = PageHelperUtils.changePageToCurrentPage(serviceResponse.getResult(), GoodsStandardValueGroupVO.class);
        return RestResponse.success(page);
    }

    @RequestMapping("/list-standard-value")
    public RestResponse listStandardValue(int currentPage, int pageSize, Long specStandardId, String search, Long specStandardValueGroupId) {
        ServiceResponse<Page<StandardValueDTO>> serviceResponse =
                standardValueApiService.listByPage(currentPage, pageSize, specStandardId, search, SortType.sortDescType, specStandardValueGroupId, getEnterpriseId());
        if (!serviceResponse.isSuccess()) {
            return RestResponse.failure(serviceResponse.getCode(), serviceResponse.getMessage());
        }
        Page<GoodsStandardValueVO> page = PageHelperUtils.changePageToCurrentPage(serviceResponse.getResult(), GoodsStandardValueVO.class);
        return RestResponse.success(page);
    }


}
