package com.gic.plug.web.strategy.impl;

import com.alibaba.fastjson.JSONObject;
import com.gic.api.base.commons.Page;
import com.gic.api.base.commons.ServiceResponse;
import com.gic.plug.web.strategy.ScreenBackStrategy;
import com.gic.plug.web.utils.ComputeBackUtil;
import com.gic.store.constant.StoreESFieldsEnum;
import com.gic.store.dto.StoreDTO;
import com.gic.store.dto.StoreSearchDTO;
import com.gic.store.service.StoreApiService;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public class StoreBackImpl implements ScreenBackStrategy {
    @Autowired
    private StoreApiService storeApiService;
    @Override
    public String screenBack(String compute, String value, String key, Integer enterpriseId) {
        if(StringUtils.isNotBlank(value)){
            StringBuilder stringBuilder = new StringBuilder(StoreESFieldsEnum.STOREID.getDesc()).append(" ");
            stringBuilder.append(ComputeBackUtil.getComputeBack(compute)).append(" ");
            StoreSearchDTO storeSearchDTO = new StoreSearchDTO();
            storeSearchDTO.setEnterpriseId(enterpriseId);
            storeSearchDTO.setStoreIds(value);
            ServiceResponse<Page<StoreDTO>> response = this.storeApiService.listStore(storeSearchDTO, 1, 50, StoreESFieldsEnum.STORENAME.getField());
            if(response.isSuccess()){
                List<StoreDTO> list = ((Page)response.getResult()).getResult();
                if(CollectionUtils.isNotEmpty(list)){
                    for (StoreDTO storeDTO : list) {
                        JSONObject jsonObject = (JSONObject) JSONObject.toJSON(storeDTO);
                        stringBuilder.append("【").append(jsonObject.getString(StoreESFieldsEnum.STORENAME.getField())).append("】").append(" ");
                    }
                }
            }
            return stringBuilder.toString();
        }
        return null;
    }
}
